<?php

// mail('sheheryar.reavertech@gmail.com', "blesta called", "its a hit");

class IdevaffiliatePlugin extends Plugin {
 
    public function __construct() {
        Loader::loadComponents($this, array("Input"));
        $this->loadConfig(dirname(__FILE__) . DS . "config.json");
    }
 
    public function install($plugin_id) {
        if (!isset($this->Record))
            Loader::loadComponents($this, array("Record"));
        
            // mail('sheheryar.reavertech@gmail.com', "Install check", "asdasd");
        try {
            // idev affiliate settings
            $this->Record->
                    setField("id", array('type'=>"int",'size'=>10,'unsigned'=>true,'auto_increment'=>true))->
                    setField("url", array('type'=>"varchar", 'size'=>255))->
                    setField("enabled", array('type'=>"int",'size'=>2,'unsigned'=>true,'default' => 0))->
                    setField("updated", array('type'=>"datetime", 'is_null'=>true, 'default'=>null))->
                    setKey(array("id"), "primary")->
                    create("idevaffiliate_settings", true);
            $this->Record->insert("idevaffiliate_settings", array('url' => '','enabled' => "0",'updated' => date("Y-m-d H:i:s")));
            
            $this->Record->
                    setField("id", array('type'=>"int",'size'=>10,'unsigned'=>true,'auto_increment'=>true))->
                    setField("invoice_id", array('type'=>"int",'size'=>10,'unsigned'=>true))->
                    setField("invoice_id_value", array('type'=>"varchar", 'size'=>255))->
                    setField("client_id", array('type'=>"int",'size'=>10,'unsigned'=>true))->
                    setField("ip_address", array('type'=>"varchar", 'size'=>255))->
                    setField("updated", array('type'=>"datetime", 'is_null'=>true, 'default'=>null))->
                    setKey(array("id"), "primary")->
                    create("idevaffiliate_userip", true);
        }
        catch (Exception $e) {
            // Error adding... no permission?
            $this->Input->setErrors(array('db'=> array('create'=>$e->getMessage())));
            return;
        }
    }

    public function uninstall($plugin_id, $last_instance) {
        if (!isset($this->Record))
            Loader::loadComponents($this, array("Record"));

            // mail('sheheryar.reavertech@gmail.com', "Uninstall check", "asdasd");
        // Remove all feed_reader tables *IFF* no other company in the system is using this plugin
        if ($last_instance) {
            $this->Record->drop("idevaffiliate_settings");
            $this->Record->drop("idevaffiliate_userip");
        }
    }

    public function upgrade($current_version, $plugin_id) {
        #
        # TODO: Place upgrade logic here
        #
    }
    
    public function getEvents() {
        return array(
            array(
                'event' => "Transactions.add",
                'callback' => array("this", "run")
            ),
            array(
                'event' => "Transactions.edit",
                'callback' => array("this","run")
            ),
            array(
                'event' => "Invoices.add",
                'callback' => array("this","run2")
            )
        );
    }
    
    public function run2($invoice) {
        // mail('sheheryar.reavertech@gmail.com', "Invoice called", "invoice details");

        $params = $invoice->getParams();
        $invoice_id = $params['invoice_id'];
        
        if (!isset($this->Record))
            Loader::loadComponents($this, array("Record"));
        
        $invoice_details = $this->Record->select()->from("invoices")->where("id", "=", $invoice_id)->limit(1)->fetchAll();
        if($invoice_details && is_array($invoice_details)) {
            $invoice_details = $invoice_details[0];
            $invoice_details->id_value = str_replace('{num}', $invoice_details->id_value, $invoice_details->id_format);
            $ip =   getenv('HTTP_CLIENT_IP') ?: getenv('HTTP_X_FORWARDED_FOR') ?:
                            getenv('HTTP_X_FORWARDED') ?: getenv('HTTP_FORWARDED_FOR')?:
                            getenv('HTTP_FORWARDED') ?: getenv('REMOTE_ADDR');
            
            $this->Record->insert("idevaffiliate_userip", array('invoice_id' => $invoice_details->id,'invoice_id_value' => $invoice_details->id_value,'client_id' => $invoice_details->client_id, 'ip_address' => $ip, 'updated' => date("Y-m-d H:i:s")));
            //$temp = print_r($invoice_details,true);
            // mail('sheheryar.reavertech@gmail.com', "Invoice called", "invoice details = $temp, ip address: $ip");
			// mail('sheheryar.reavertech@gmail.com', "Invoice deets", $invoice_details,true);
        }
        
        


    }
    
    public function run($transaction) {
        // mail('sheheryar.reavertech@gmail.com', "Transaction called", "invoice detail");
        
        // This will execute when the "Transactions.add" event is triggered
        if (!isset($this->Record))
            Loader::loadComponents($this, array("Record"));
        
        if (!isset($this->Transactions))
                Loader::loadModels($this, array("Transactions"));
        
        
        $params = $transaction->getParams();
        $transaction_id = $params['transaction_id'];
        
        $settings = $this->Record->select()->from("idevaffiliate_settings")->limit(1)->fetchAll();
        
        if($settings && is_array($settings))
            $settings = $settings[0];
                
        //check enabled or not 
        if($settings && (int)$settings->enabled === 1) {
            // Now get transaction details
            $transaction_details = $this->Transactions->get($transaction_id);
            
            if($transaction_details && $transaction_details->status === 'approved') {
                
                //get ip address 
                $ip = "";
                $client_id = $transaction_details->client_id;
                $ip_data = $this->Record->select()->from("idevaffiliate_userip")->where("client_id", "=", $client_id)->order(array("idevaffiliate_userip.invoice_id_value"=>"DESC"))->limit(1)->fetchAll();
                
                
                
                if($ip_data && is_array($ip_data))
                    $ip_data = $ip_data[0];
                
                // mail('sheheryar.reavertech@gmail.com','ip_data2',  print_r($ip_data,true));
                
                if($ip_data->ip_address != '') {
                    $ip = $ip_data->ip_address; 
                    // mail('sheheryar.reavertech@gmail.com','ip from database',"ip now: $ip");
                }
                else {
                    $ip =   getenv('HTTP_CLIENT_IP') ?: getenv('HTTP_X_FORWARDED_FOR') ?:
                            getenv('HTTP_X_FORWARDED') ?: getenv('HTTP_FORWARDED_FOR')?:
                            getenv('HTTP_FORWARDED') ?: getenv('REMOTE_ADDR');
                    // mail('sheheryar.reavertech@gmail.com','ip from local',"ip now: $ip");
                }
                
                
                
                $url = $settings->url . 'sale.php';
               
                $data = array(
                    "profile" => "108",
                    "idev_saleamt" => floatval($transaction_details->amount),
                    'sale_status' => $transaction_details->status,
                    "idev_ordernum" => $transaction_details->transaction_id!=''?$transaction_details->transaction_id:$transaction_details->id,
                    'ip_address' => $ip,
                );

                // mail('sheheryar.reavertech@gmail.com','Transaction Payload',json_encode($data));
                $ch = curl_init();   
                curl_setopt($ch, CURLOPT_URL, $url);                                    
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);  
                curl_setopt($ch, CURLOPT_HEADER, 0);  
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $data);  
                $json = curl_exec($ch);

                if($errno = curl_errno($cURLConnection)) {
                    // $error_message = curl_strerror($errno);

                    // $postRequest = array(
                    //     'firstFieldData' => json_encode($error_message)
                    // );
                
                    // $cURLConnection = curl_init('https://connect.pabbly.com/workflow/sendwebhookdata/IjM4NDk5MiI_3D');
                    // curl_setopt($cURLConnection, CURLOPT_POSTFIELDS,$data);
                    // curl_setopt($cURLConnection, CURLOPT_RETURNTRANSFER, true);
                    
                    // $apiResponse = curl_exec($cURLConnection);
                    // curl_close($cURLConnection);

                    
                }
                
                curl_close($ch);
            }
        }
    }
}
?>