<?php

class IdevaffiliateSettingsModel extends IdevaffiliateModel {
	
	/**
	 * Initialize Feeds
	 */
	public function __construct() {
		parent::__construct();
		//Language::loadLang("feed_reader_feeds", null, PLUGINDIR . "feed_reader" . DS . "language" . DS);
	}
	
	
	public function editSettings(array $vars) {
		
		$rules = array(
                    'url'=>array(
                            'valid'=>array(
                                    'rule'=>"isEmpty",
                                    'negate'=>true,
                                    'message'=>$this->_("Invalid URL")
                            )
                    )
		);
		
		$this->Input->setRules($rules);
		
		if ($this->Input->validates($vars)) {
                    //$vars['url'], $vars['']
                    //update database table
                    $data['url'] = $vars['url'];
                    $data['enabled'] = $vars['enabled'];
                    $data['updated'] = date("Y-m-d H:i:s"); 
                    
                    $settings_id = isset($vars['settings_id']) ? (int) $vars['settings_id'] : 1;
                    if($settings_id === 0) {
                        $settings_id = 1;
                    }
                    
                    $this->Record->where("id", "=", $settings_id)->update("idevaffiliate_settings", $data, array("url","enabled","updated"));
                    
		}
	}
	
	public function getSettings() {
            return $this->Record->select()->from("idevaffiliate_settings")->limit(1)->fetch();
	}
}
?>